/* game-view.c generated by valac 0.23.3.7-fa26, the Vala compiler
 * generated from game-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <librsvg/rsvg.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
typedef struct _GameViewPrivate GameViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;

#define TYPE_PLAYER (player_get_type ())

struct _GameView {
	GtkDrawingArea parent_instance;
	GameViewPrivate * priv;
};

struct _GameViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _GameViewPrivate {
	guint render_size;
	cairo_pattern_t* tiles_pattern;
	gint* pixmaps;
	gint pixmaps_length1;
	gint pixmaps_length2;
	guint animate_timeout;
	gboolean flip_final_result_now;
	Game* _game;
	gchar* _theme;
};

struct _Block1Data {
	int _ref_count_;
	GameView* self;
	gint x;
	gint y;
};

typedef enum  {
	PLAYER_NONE,
	PLAYER_LIGHT,
	PLAYER_DARK
} Player;


static gpointer game_view_parent_class = NULL;

GType game_view_get_type (void) G_GNUC_CONST;
GType game_get_type (void) G_GNUC_CONST;
#define GAME_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GAME_VIEW, GameViewPrivate))
enum  {
	GAME_VIEW_DUMMY_PROPERTY,
	GAME_VIEW_GAME,
	GAME_VIEW_THEME
};
#define GAME_VIEW_GRID_WIDTH 1
#define GAME_VIEW_PIXMAP_FLIP_DELAY 20
GameView* game_view_new (void);
GameView* game_view_construct (GType object_type);
static GtkSizeRequestMode game_view_real_get_request_mode (GtkWidget* base);
static void game_view_real_get_preferred_width_for_height (GtkWidget* base, gint height, gint* minimum_width, gint* natural_width);
static void game_view_real_get_preferred_width (GtkWidget* base, gint* minimum, gint* natural);
static void game_view_real_get_preferred_height (GtkWidget* base, gint* minimum, gint* natural);
static gboolean game_view_real_draw (GtkWidget* base, cairo_t* cr);
Game* game_view_get_game (GameView* self);
static gint game_view_get_tile_size (GameView* self);
static void game_view_load_theme (GameView* self, cairo_t* c);
static gint game_view_get_x_offset (GameView* self);
static gint game_view_get_y_offset (GameView* self);
static gint game_view_get_board_size (GameView* self);
const gchar* game_view_get_theme (GameView* self);
void game_view_redraw (GameView* self);
static void game_view_square_changed_cb (GameView* self, gint x, gint y);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
GType player_get_type (void) G_GNUC_CONST;
static gint game_view_get_pixmap (GameView* self, Player color);
Player game_get_owner (Game* self, gint x, gint y);
gboolean game_is_complete (Game* self);
gint game_get_width (Game* self);
gint game_get_n_light_tiles (Game* self);
gint game_get_n_dark_tiles (Game* self);
static void game_view_set_square (GameView* self, gint x, gint y, gint pixmap);
static gboolean ___lambda3_ (Block1Data* _data1_);
static gboolean ____lambda3__gsource_func (gpointer self);
static gboolean game_view_animate_cb (GameView* self);
static gboolean _game_view_animate_cb_gsource_func (gpointer self);
static gboolean game_view_real_button_press_event (GtkWidget* base, GdkEventButton* event);
void game_view_set_game (GameView* self, Game* value);
static void _game_view_square_changed_cb_game_square_changed (Game* _sender, gint x, gint y, gpointer self);
void game_view_set_theme (GameView* self, const gchar* value);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void game_view_finalize (GObject* obj);
static void _vala_game_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_game_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GameView* game_view_construct (GType object_type) {
	GameView * self = NULL;
	gint* _tmp0_ = NULL;
	self = (GameView*) g_object_new (object_type, NULL);
	gtk_widget_set_events ((GtkWidget*) self, (gint) (GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK));
	_tmp0_ = g_new0 (gint, 8 * 8);
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
	self->priv->pixmaps = _tmp0_;
	self->priv->pixmaps_length1 = 8;
	self->priv->pixmaps_length2 = 8;
	return self;
}


GameView* game_view_new (void) {
	return game_view_construct (TYPE_GAME_VIEW);
}


static GtkSizeRequestMode game_view_real_get_request_mode (GtkWidget* base) {
	GameView * self;
	GtkSizeRequestMode result = 0;
	self = (GameView*) base;
	result = GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT;
	return result;
}


static void game_view_real_get_preferred_width_for_height (GtkWidget* base, gint height, gint* minimum_width, gint* natural_width) {
	GameView * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gint _tmp0_ = 0;
	self = (GameView*) base;
	_tmp0_ = height;
	_vala_natural_width = _tmp0_;
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static void game_view_real_get_preferred_width (GtkWidget* base, gint* minimum, gint* natural) {
	GameView * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	self = (GameView*) base;
	_vala_natural = (gint) (8 * (20 + GAME_VIEW_GRID_WIDTH));
	_vala_minimum = _vala_natural;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}


static void game_view_real_get_preferred_height (GtkWidget* base, gint* minimum, gint* natural) {
	GameView * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	self = (GameView*) base;
	_vala_natural = (gint) (8 * (20 + GAME_VIEW_GRID_WIDTH));
	_vala_minimum = _vala_natural;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}


static gboolean game_view_real_draw (GtkWidget* base, cairo_t* cr) {
	GameView * self;
	gboolean result = FALSE;
	Game* _tmp0_ = NULL;
	Game* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	cairo_pattern_t* _tmp3_ = NULL;
	cairo_t* _tmp65_ = NULL;
	cairo_t* _tmp66_ = NULL;
	cairo_t* _tmp67_ = NULL;
	cairo_t* _tmp93_ = NULL;
	gint _tmp94_ = 0;
	gint _tmp95_ = 0;
	gint _tmp96_ = 0;
	gint _tmp97_ = 0;
	gint _tmp98_ = 0;
	gint _tmp99_ = 0;
	gint _tmp100_ = 0;
	gint _tmp101_ = 0;
	cairo_t* _tmp102_ = NULL;
	self = (GameView*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = game_view_get_game (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp3_ = self->priv->tiles_pattern;
	if (_tmp3_ == NULL) {
		_tmp2_ = TRUE;
	} else {
		guint _tmp4_ = 0U;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		_tmp4_ = self->priv->render_size;
		_tmp5_ = game_view_get_tile_size (self);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp4_ != ((guint) _tmp6_);
	}
	if (_tmp2_) {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		cairo_surface_t* surface = NULL;
		cairo_t* _tmp9_ = NULL;
		cairo_surface_t* _tmp10_ = NULL;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		cairo_surface_t* _tmp15_ = NULL;
		cairo_t* c = NULL;
		cairo_surface_t* _tmp16_ = NULL;
		cairo_t* _tmp17_ = NULL;
		cairo_t* _tmp18_ = NULL;
		cairo_surface_t* _tmp19_ = NULL;
		cairo_pattern_t* _tmp20_ = NULL;
		_tmp7_ = game_view_get_tile_size (self);
		_tmp8_ = _tmp7_;
		self->priv->render_size = (guint) _tmp8_;
		_tmp9_ = cr;
		_tmp10_ = cairo_get_target (_tmp9_);
		_tmp11_ = game_view_get_tile_size (self);
		_tmp12_ = _tmp11_;
		_tmp13_ = game_view_get_tile_size (self);
		_tmp14_ = _tmp13_;
		_tmp15_ = cairo_surface_create_similar (_tmp10_, CAIRO_CONTENT_COLOR_ALPHA, _tmp12_ * 8, _tmp14_ * 4);
		surface = _tmp15_;
		_tmp16_ = surface;
		_tmp17_ = cairo_create (_tmp16_);
		c = _tmp17_;
		_tmp18_ = c;
		game_view_load_theme (self, _tmp18_);
		_tmp19_ = surface;
		_tmp20_ = cairo_pattern_create_for_surface (_tmp19_);
		_cairo_pattern_destroy0 (self->priv->tiles_pattern);
		self->priv->tiles_pattern = _tmp20_;
		_cairo_destroy0 (c);
		_cairo_surface_destroy0 (surface);
	}
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp21_ = FALSE;
			_tmp21_ = TRUE;
			while (TRUE) {
				gint _tmp23_ = 0;
				if (!_tmp21_) {
					gint _tmp22_ = 0;
					_tmp22_ = x;
					x = _tmp22_ + 1;
				}
				_tmp21_ = FALSE;
				_tmp23_ = x;
				if (!(_tmp23_ < 8)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp24_ = FALSE;
						_tmp24_ = TRUE;
						while (TRUE) {
							gint _tmp26_ = 0;
							gint tile_x = 0;
							gint _tmp27_ = 0;
							gint _tmp28_ = 0;
							gint _tmp29_ = 0;
							gint _tmp30_ = 0;
							gint _tmp31_ = 0;
							gint tile_y = 0;
							gint _tmp32_ = 0;
							gint _tmp33_ = 0;
							gint _tmp34_ = 0;
							gint _tmp35_ = 0;
							gint _tmp36_ = 0;
							gint texture_x = 0;
							gint* _tmp37_ = NULL;
							gint _tmp37__length1 = 0;
							gint _tmp37__length2 = 0;
							gint _tmp38_ = 0;
							gint _tmp39_ = 0;
							gint _tmp40_ = 0;
							gint _tmp41_ = 0;
							gint _tmp42_ = 0;
							gint texture_y = 0;
							gint* _tmp43_ = NULL;
							gint _tmp43__length1 = 0;
							gint _tmp43__length2 = 0;
							gint _tmp44_ = 0;
							gint _tmp45_ = 0;
							gint _tmp46_ = 0;
							gint _tmp47_ = 0;
							gint _tmp48_ = 0;
							cairo_matrix_t matrix = {0};
							gint _tmp49_ = 0;
							gint _tmp50_ = 0;
							gint _tmp51_ = 0;
							gint _tmp52_ = 0;
							cairo_pattern_t* _tmp53_ = NULL;
							cairo_matrix_t _tmp54_ = {0};
							cairo_t* _tmp55_ = NULL;
							cairo_pattern_t* _tmp56_ = NULL;
							cairo_t* _tmp57_ = NULL;
							gint _tmp58_ = 0;
							gint _tmp59_ = 0;
							gint _tmp60_ = 0;
							gint _tmp61_ = 0;
							gint _tmp62_ = 0;
							gint _tmp63_ = 0;
							cairo_t* _tmp64_ = NULL;
							if (!_tmp24_) {
								gint _tmp25_ = 0;
								_tmp25_ = y;
								y = _tmp25_ + 1;
							}
							_tmp24_ = FALSE;
							_tmp26_ = y;
							if (!(_tmp26_ < 8)) {
								break;
							}
							_tmp27_ = game_view_get_x_offset (self);
							_tmp28_ = _tmp27_;
							_tmp29_ = x;
							_tmp30_ = game_view_get_tile_size (self);
							_tmp31_ = _tmp30_;
							tile_x = _tmp28_ + (_tmp29_ * (_tmp31_ + GAME_VIEW_GRID_WIDTH));
							_tmp32_ = game_view_get_y_offset (self);
							_tmp33_ = _tmp32_;
							_tmp34_ = y;
							_tmp35_ = game_view_get_tile_size (self);
							_tmp36_ = _tmp35_;
							tile_y = _tmp33_ + (_tmp34_ * (_tmp36_ + GAME_VIEW_GRID_WIDTH));
							_tmp37_ = self->priv->pixmaps;
							_tmp37__length1 = self->priv->pixmaps_length1;
							_tmp37__length2 = self->priv->pixmaps_length2;
							_tmp38_ = x;
							_tmp39_ = y;
							_tmp40_ = _tmp37_[(_tmp38_ * _tmp37__length2) + _tmp39_];
							_tmp41_ = game_view_get_tile_size (self);
							_tmp42_ = _tmp41_;
							texture_x = (_tmp40_ % 8) * _tmp42_;
							_tmp43_ = self->priv->pixmaps;
							_tmp43__length1 = self->priv->pixmaps_length1;
							_tmp43__length2 = self->priv->pixmaps_length2;
							_tmp44_ = x;
							_tmp45_ = y;
							_tmp46_ = _tmp43_[(_tmp44_ * _tmp43__length2) + _tmp45_];
							_tmp47_ = game_view_get_tile_size (self);
							_tmp48_ = _tmp47_;
							texture_y = (_tmp46_ / 8) * _tmp48_;
							cairo_matrix_init_identity (&matrix);
							_tmp49_ = texture_x;
							_tmp50_ = tile_x;
							_tmp51_ = texture_y;
							_tmp52_ = tile_y;
							cairo_matrix_translate (&matrix, (gdouble) (_tmp49_ - _tmp50_), (gdouble) (_tmp51_ - _tmp52_));
							_tmp53_ = self->priv->tiles_pattern;
							_tmp54_ = matrix;
							cairo_pattern_set_matrix (_tmp53_, &_tmp54_);
							_tmp55_ = cr;
							_tmp56_ = self->priv->tiles_pattern;
							cairo_set_source (_tmp55_, _tmp56_);
							_tmp57_ = cr;
							_tmp58_ = tile_x;
							_tmp59_ = tile_y;
							_tmp60_ = game_view_get_tile_size (self);
							_tmp61_ = _tmp60_;
							_tmp62_ = game_view_get_tile_size (self);
							_tmp63_ = _tmp62_;
							cairo_rectangle (_tmp57_, (gdouble) _tmp58_, (gdouble) _tmp59_, (gdouble) _tmp61_, (gdouble) _tmp63_);
							_tmp64_ = cr;
							cairo_fill (_tmp64_);
						}
					}
				}
			}
		}
	}
	_tmp65_ = cr;
	cairo_set_source_rgba (_tmp65_, 1.0, 1.0, 1.0, 1.0);
	_tmp66_ = cr;
	cairo_set_operator (_tmp66_, CAIRO_OPERATOR_DIFFERENCE);
	_tmp67_ = cr;
	cairo_set_line_width (_tmp67_, (gdouble) GAME_VIEW_GRID_WIDTH);
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp68_ = FALSE;
			_tmp68_ = TRUE;
			while (TRUE) {
				gint _tmp70_ = 0;
				cairo_t* _tmp71_ = NULL;
				gint _tmp72_ = 0;
				gint _tmp73_ = 0;
				gint _tmp74_ = 0;
				gint _tmp75_ = 0;
				gint _tmp76_ = 0;
				gint _tmp77_ = 0;
				gint _tmp78_ = 0;
				cairo_t* _tmp79_ = NULL;
				gint _tmp80_ = 0;
				gint _tmp81_ = 0;
				cairo_t* _tmp82_ = NULL;
				gint _tmp83_ = 0;
				gint _tmp84_ = 0;
				gint _tmp85_ = 0;
				gint _tmp86_ = 0;
				gint _tmp87_ = 0;
				gint _tmp88_ = 0;
				gint _tmp89_ = 0;
				cairo_t* _tmp90_ = NULL;
				gint _tmp91_ = 0;
				gint _tmp92_ = 0;
				if (!_tmp68_) {
					gint _tmp69_ = 0;
					_tmp69_ = i;
					i = _tmp69_ + 1;
				}
				_tmp68_ = FALSE;
				_tmp70_ = i;
				if (!(_tmp70_ < 8)) {
					break;
				}
				_tmp71_ = cr;
				_tmp72_ = game_view_get_x_offset (self);
				_tmp73_ = _tmp72_;
				_tmp74_ = i;
				_tmp75_ = game_view_get_board_size (self);
				_tmp76_ = _tmp75_;
				_tmp77_ = game_view_get_y_offset (self);
				_tmp78_ = _tmp77_;
				cairo_move_to (_tmp71_, (_tmp73_ + ((_tmp74_ * _tmp76_) / 8)) - 0.5, (gdouble) _tmp78_);
				_tmp79_ = cr;
				_tmp80_ = game_view_get_board_size (self);
				_tmp81_ = _tmp80_;
				cairo_rel_line_to (_tmp79_, (gdouble) 0, (gdouble) _tmp81_);
				_tmp82_ = cr;
				_tmp83_ = game_view_get_x_offset (self);
				_tmp84_ = _tmp83_;
				_tmp85_ = game_view_get_y_offset (self);
				_tmp86_ = _tmp85_;
				_tmp87_ = i;
				_tmp88_ = game_view_get_board_size (self);
				_tmp89_ = _tmp88_;
				cairo_move_to (_tmp82_, (gdouble) _tmp84_, (_tmp86_ + ((_tmp87_ * _tmp89_) / 8)) - 0.5);
				_tmp90_ = cr;
				_tmp91_ = game_view_get_board_size (self);
				_tmp92_ = _tmp91_;
				cairo_rel_line_to (_tmp90_, (gdouble) _tmp92_, (gdouble) 0);
			}
		}
	}
	_tmp93_ = cr;
	_tmp94_ = game_view_get_x_offset (self);
	_tmp95_ = _tmp94_;
	_tmp96_ = game_view_get_y_offset (self);
	_tmp97_ = _tmp96_;
	_tmp98_ = game_view_get_board_size (self);
	_tmp99_ = _tmp98_;
	_tmp100_ = game_view_get_board_size (self);
	_tmp101_ = _tmp100_;
	cairo_rectangle (_tmp93_, _tmp95_ + 0.5, _tmp97_ + 0.5, (gdouble) (_tmp99_ - 1), (gdouble) (_tmp101_ - 1));
	_tmp102_ = cr;
	cairo_stroke (_tmp102_);
	result = FALSE;
	return result;
}


static void game_view_load_theme (GameView* self, cairo_t* c) {
	gint width = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint height = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = game_view_get_tile_size (self);
	_tmp1_ = _tmp0_;
	width = _tmp1_ * 8;
	_tmp2_ = game_view_get_tile_size (self);
	_tmp3_ = _tmp2_;
	height = _tmp3_ * 4;
	{
		RsvgHandle* h = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		RsvgHandle* _tmp6_ = NULL;
		cairo_matrix_t m = {0};
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		cairo_t* _tmp11_ = NULL;
		cairo_matrix_t _tmp12_ = {0};
		cairo_t* _tmp13_ = NULL;
		_tmp4_ = game_view_get_theme (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = rsvg_handle_new_from_file (_tmp5_, &_inner_error_);
		h = _tmp6_;
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		cairo_matrix_init_identity (&m);
		g_object_get (h, "width", &_tmp7_, NULL);
		_tmp8_ = _tmp7_;
		g_object_get (h, "height", &_tmp9_, NULL);
		_tmp10_ = _tmp9_;
		cairo_matrix_scale (&m, ((gdouble) width) / _tmp8_, ((gdouble) height) / _tmp10_);
		_tmp11_ = c;
		_tmp12_ = m;
		cairo_set_matrix (_tmp11_, &_tmp12_);
		_tmp13_ = c;
		rsvg_handle_render_cairo (h, _tmp13_);
		_g_object_unref0 (h);
		return;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GdkPixbuf* p = NULL;
		const gchar* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		GdkPixbuf* _tmp16_ = NULL;
		cairo_t* _tmp17_ = NULL;
		GdkPixbuf* _tmp18_ = NULL;
		cairo_t* _tmp19_ = NULL;
		_tmp14_ = game_view_get_theme (self);
		_tmp15_ = _tmp14_;
		_tmp16_ = gdk_pixbuf_new_from_file_at_scale (_tmp15_, width, height, FALSE, &_inner_error_);
		p = _tmp16_;
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_tmp17_ = c;
		_tmp18_ = p;
		gdk_cairo_set_source_pixbuf (_tmp17_, _tmp18_, (gdouble) 0, (gdouble) 0);
		_tmp19_ = c;
		cairo_paint (_tmp19_);
		_g_object_unref0 (p);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		GError* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = game_view_get_theme (self);
		_tmp21_ = _tmp20_;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		g_warning ("game-view.vala:195: Failed to load theme %s: %s", _tmp21_, _tmp23_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void game_view_redraw (GameView* self) {
	g_return_if_fail (self != NULL);
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		GameView* self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean ___lambda3_ (Block1Data* _data1_) {
	GameView* self;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	self = _data1_->self;
	self->priv->flip_final_result_now = TRUE;
	_tmp0_ = _data1_->x;
	_tmp1_ = _data1_->y;
	game_view_square_changed_cb (self, _tmp0_, _tmp1_);
	result = FALSE;
	return result;
}


static gboolean ____lambda3__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda3_ (self);
	return result;
}


static void game_view_square_changed_cb (GameView* self, gint x, gint y) {
	Block1Data* _data1_;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint pixmap = 0;
	Game* _tmp2_ = NULL;
	Game* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	Player _tmp6_ = 0;
	gint _tmp7_ = 0;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gint _tmp47_ = 0;
	gint _tmp48_ = 0;
	gint _tmp49_ = 0;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
	Game* _tmp52_ = NULL;
	Game* _tmp53_ = NULL;
	gboolean _tmp54_ = FALSE;
	g_return_if_fail (self != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = x;
	_data1_->x = _tmp0_;
	_tmp1_ = y;
	_data1_->y = _tmp1_;
	_tmp2_ = game_view_get_game (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = _data1_->x;
	_tmp5_ = _data1_->y;
	_tmp6_ = game_get_owner (_tmp3_, _tmp4_, _tmp5_);
	_tmp7_ = game_view_get_pixmap (self, _tmp6_);
	pixmap = _tmp7_;
	_tmp9_ = self->priv->flip_final_result_now;
	if (_tmp9_) {
		Game* _tmp10_ = NULL;
		Game* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		_tmp10_ = game_view_get_game (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = game_is_complete (_tmp11_);
		_tmp8_ = _tmp12_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		gint n = 0;
		gint _tmp13_ = 0;
		Game* _tmp14_ = NULL;
		Game* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		gint _tmp18_ = 0;
		Player winning_color = 0;
		Player losing_color = 0;
		gint n_winning_tiles = 0;
		Game* _tmp19_ = NULL;
		Game* _tmp20_ = NULL;
		gint _tmp21_ = 0;
		gint _tmp22_ = 0;
		gint n_losing_tiles = 0;
		Game* _tmp23_ = NULL;
		Game* _tmp24_ = NULL;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
		gint _tmp28_ = 0;
		gint _tmp32_ = 0;
		gint _tmp33_ = 0;
		_tmp13_ = _data1_->y;
		_tmp14_ = game_view_get_game (self);
		_tmp15_ = _tmp14_;
		_tmp16_ = game_get_width (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = _data1_->x;
		n = (_tmp13_ * _tmp17_) + _tmp18_;
		winning_color = PLAYER_LIGHT;
		losing_color = PLAYER_DARK;
		_tmp19_ = game_view_get_game (self);
		_tmp20_ = _tmp19_;
		_tmp21_ = game_get_n_light_tiles (_tmp20_);
		_tmp22_ = _tmp21_;
		n_winning_tiles = _tmp22_;
		_tmp23_ = game_view_get_game (self);
		_tmp24_ = _tmp23_;
		_tmp25_ = game_get_n_dark_tiles (_tmp24_);
		_tmp26_ = _tmp25_;
		n_losing_tiles = _tmp26_;
		_tmp27_ = n_losing_tiles;
		_tmp28_ = n_winning_tiles;
		if (_tmp27_ > _tmp28_) {
			gint t = 0;
			gint _tmp29_ = 0;
			gint _tmp30_ = 0;
			gint _tmp31_ = 0;
			winning_color = PLAYER_DARK;
			losing_color = PLAYER_LIGHT;
			_tmp29_ = n_winning_tiles;
			t = _tmp29_;
			_tmp30_ = n_losing_tiles;
			n_winning_tiles = _tmp30_;
			_tmp31_ = t;
			n_losing_tiles = _tmp31_;
		}
		_tmp32_ = n;
		_tmp33_ = n_winning_tiles;
		if (_tmp32_ < _tmp33_) {
			Player _tmp34_ = 0;
			gint _tmp35_ = 0;
			_tmp34_ = winning_color;
			_tmp35_ = game_view_get_pixmap (self, _tmp34_);
			pixmap = _tmp35_;
		} else {
			gint _tmp36_ = 0;
			gint _tmp37_ = 0;
			gint _tmp38_ = 0;
			_tmp36_ = n;
			_tmp37_ = n_winning_tiles;
			_tmp38_ = n_losing_tiles;
			if (_tmp36_ < (_tmp37_ + _tmp38_)) {
				Player _tmp39_ = 0;
				gint _tmp40_ = 0;
				_tmp39_ = losing_color;
				_tmp40_ = game_view_get_pixmap (self, _tmp39_);
				pixmap = _tmp40_;
			} else {
				gint _tmp41_ = 0;
				_tmp41_ = game_view_get_pixmap (self, PLAYER_NONE);
				pixmap = _tmp41_;
			}
		}
	} else {
		gboolean _tmp42_ = FALSE;
		gboolean _tmp43_ = FALSE;
		_tmp43_ = self->priv->flip_final_result_now;
		if (_tmp43_) {
			Game* _tmp44_ = NULL;
			Game* _tmp45_ = NULL;
			gboolean _tmp46_ = FALSE;
			_tmp44_ = game_view_get_game (self);
			_tmp45_ = _tmp44_;
			_tmp46_ = game_is_complete (_tmp45_);
			_tmp42_ = !_tmp46_;
		} else {
			_tmp42_ = FALSE;
		}
		if (_tmp42_) {
			self->priv->flip_final_result_now = FALSE;
		}
	}
	_tmp47_ = _data1_->x;
	_tmp48_ = _data1_->y;
	_tmp49_ = pixmap;
	game_view_set_square (self, _tmp47_, _tmp48_, _tmp49_);
	_tmp52_ = game_view_get_game (self);
	_tmp53_ = _tmp52_;
	_tmp54_ = game_is_complete (_tmp53_);
	if (_tmp54_) {
		Game* _tmp55_ = NULL;
		Game* _tmp56_ = NULL;
		gint _tmp57_ = 0;
		gint _tmp58_ = 0;
		_tmp55_ = game_view_get_game (self);
		_tmp56_ = _tmp55_;
		_tmp57_ = game_get_n_light_tiles (_tmp56_);
		_tmp58_ = _tmp57_;
		_tmp51_ = _tmp58_ > 0;
	} else {
		_tmp51_ = FALSE;
	}
	if (_tmp51_) {
		Game* _tmp59_ = NULL;
		Game* _tmp60_ = NULL;
		gint _tmp61_ = 0;
		gint _tmp62_ = 0;
		_tmp59_ = game_view_get_game (self);
		_tmp60_ = _tmp59_;
		_tmp61_ = game_get_n_dark_tiles (_tmp60_);
		_tmp62_ = _tmp61_;
		_tmp50_ = _tmp62_ > 0;
	} else {
		_tmp50_ = FALSE;
	}
	if (_tmp50_) {
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ____lambda3__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	}
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static gboolean _game_view_animate_cb_gsource_func (gpointer self) {
	gboolean result;
	result = game_view_animate_cb ((GameView*) self);
	return result;
}


static void game_view_set_square (GameView* self, gint x, gint y, gint pixmap) {
	gint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_ = 0;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	gint _tmp35_ = 0;
	gint _tmp36_ = 0;
	gint _tmp37_ = 0;
	gint _tmp38_ = 0;
	gint _tmp39_ = 0;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pixmaps;
	_tmp0__length1 = self->priv->pixmaps_length1;
	_tmp0__length2 = self->priv->pixmaps_length2;
	_tmp1_ = x;
	_tmp2_ = y;
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
	_tmp4_ = pixmap;
	if (_tmp3_ == _tmp4_) {
		return;
	}
	_tmp6_ = pixmap;
	if (_tmp6_ == 0) {
		_tmp5_ = TRUE;
	} else {
		gint* _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		gint _tmp7__length2 = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		_tmp7_ = self->priv->pixmaps;
		_tmp7__length1 = self->priv->pixmaps_length1;
		_tmp7__length2 = self->priv->pixmaps_length2;
		_tmp8_ = x;
		_tmp9_ = y;
		_tmp10_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
		_tmp5_ = _tmp10_ == 0;
	}
	if (_tmp5_) {
		gint* _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		gint _tmp11__length2 = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		_tmp11_ = self->priv->pixmaps;
		_tmp11__length1 = self->priv->pixmaps_length1;
		_tmp11__length2 = self->priv->pixmaps_length2;
		_tmp12_ = x;
		_tmp13_ = y;
		_tmp14_ = pixmap;
		_tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_] = _tmp14_;
		_tmp15_ = _tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_];
	} else {
		gint _tmp16_ = 0;
		gint* _tmp17_ = NULL;
		gint _tmp17__length1 = 0;
		gint _tmp17__length2 = 0;
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
		guint _tmp29_ = 0U;
		_tmp16_ = pixmap;
		_tmp17_ = self->priv->pixmaps;
		_tmp17__length1 = self->priv->pixmaps_length1;
		_tmp17__length2 = self->priv->pixmaps_length2;
		_tmp18_ = x;
		_tmp19_ = y;
		_tmp20_ = _tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_];
		if (_tmp16_ > _tmp20_) {
			gint* _tmp21_ = NULL;
			gint _tmp21__length1 = 0;
			gint _tmp21__length2 = 0;
			gint _tmp22_ = 0;
			gint _tmp23_ = 0;
			gint _tmp24_ = 0;
			_tmp21_ = self->priv->pixmaps;
			_tmp21__length1 = self->priv->pixmaps_length1;
			_tmp21__length2 = self->priv->pixmaps_length2;
			_tmp22_ = x;
			_tmp23_ = y;
			_tmp24_ = _tmp21_[(_tmp22_ * _tmp21__length2) + _tmp23_];
			_tmp21_[(_tmp22_ * _tmp21__length2) + _tmp23_] = _tmp24_ + 1;
		} else {
			gint* _tmp25_ = NULL;
			gint _tmp25__length1 = 0;
			gint _tmp25__length2 = 0;
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			_tmp25_ = self->priv->pixmaps;
			_tmp25__length1 = self->priv->pixmaps_length1;
			_tmp25__length2 = self->priv->pixmaps_length2;
			_tmp26_ = x;
			_tmp27_ = y;
			_tmp28_ = _tmp25_[(_tmp26_ * _tmp25__length2) + _tmp27_];
			_tmp25_[(_tmp26_ * _tmp25__length2) + _tmp27_] = _tmp28_ - 1;
		}
		_tmp29_ = self->priv->animate_timeout;
		if (_tmp29_ == ((guint) 0)) {
			guint _tmp30_ = 0U;
			_tmp30_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GAME_VIEW_PIXMAP_FLIP_DELAY, _game_view_animate_cb_gsource_func, g_object_ref (self), g_object_unref);
			self->priv->animate_timeout = _tmp30_;
		}
	}
	_tmp31_ = game_view_get_x_offset (self);
	_tmp32_ = _tmp31_;
	_tmp33_ = x;
	_tmp34_ = game_view_get_tile_size (self);
	_tmp35_ = _tmp34_;
	_tmp36_ = game_view_get_y_offset (self);
	_tmp37_ = _tmp36_;
	_tmp38_ = y;
	_tmp39_ = game_view_get_tile_size (self);
	_tmp40_ = _tmp39_;
	_tmp41_ = game_view_get_tile_size (self);
	_tmp42_ = _tmp41_;
	_tmp43_ = game_view_get_tile_size (self);
	_tmp44_ = _tmp43_;
	gtk_widget_queue_draw_area ((GtkWidget*) self, _tmp32_ + (_tmp33_ * ((gint) (_tmp35_ + GAME_VIEW_GRID_WIDTH))), _tmp37_ + (_tmp38_ * ((gint) (_tmp40_ + GAME_VIEW_GRID_WIDTH))), _tmp42_, _tmp44_);
}


static gboolean game_view_animate_cb (GameView* self) {
	gboolean result = FALSE;
	gboolean animating = FALSE;
	gboolean _tmp17_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	animating = FALSE;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_ = 0;
				if (!_tmp0_) {
					gint _tmp1_ = 0;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = x;
				if (!(_tmp2_ < 8)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							gint _tmp5_ = 0;
							gint old = 0;
							gint* _tmp6_ = NULL;
							gint _tmp6__length1 = 0;
							gint _tmp6__length2 = 0;
							gint _tmp7_ = 0;
							gint _tmp8_ = 0;
							gint _tmp9_ = 0;
							gint _tmp10_ = 0;
							gint _tmp11_ = 0;
							gint* _tmp12_ = NULL;
							gint _tmp12__length1 = 0;
							gint _tmp12__length2 = 0;
							gint _tmp13_ = 0;
							gint _tmp14_ = 0;
							gint _tmp15_ = 0;
							gint _tmp16_ = 0;
							if (!_tmp3_) {
								gint _tmp4_ = 0;
								_tmp4_ = y;
								y = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							_tmp5_ = y;
							if (!(_tmp5_ < 8)) {
								break;
							}
							_tmp6_ = self->priv->pixmaps;
							_tmp6__length1 = self->priv->pixmaps_length1;
							_tmp6__length2 = self->priv->pixmaps_length2;
							_tmp7_ = x;
							_tmp8_ = y;
							_tmp9_ = _tmp6_[(_tmp7_ * _tmp6__length2) + _tmp8_];
							old = _tmp9_;
							_tmp10_ = x;
							_tmp11_ = y;
							game_view_square_changed_cb (self, _tmp10_, _tmp11_);
							_tmp12_ = self->priv->pixmaps;
							_tmp12__length1 = self->priv->pixmaps_length1;
							_tmp12__length2 = self->priv->pixmaps_length2;
							_tmp13_ = x;
							_tmp14_ = y;
							_tmp15_ = _tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_];
							_tmp16_ = old;
							if (_tmp15_ != _tmp16_) {
								animating = TRUE;
							}
						}
					}
				}
			}
		}
	}
	_tmp17_ = animating;
	if (!_tmp17_) {
		self->priv->animate_timeout = (guint) 0;
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


static gint game_view_get_pixmap (GameView* self, Player color) {
	gint result = 0;
	Player _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = color;
	switch (_tmp0_) {
		default:
		case PLAYER_NONE:
		{
			result = 0;
			return result;
		}
		case PLAYER_DARK:
		{
			result = 1;
			return result;
		}
		case PLAYER_LIGHT:
		{
			result = 31;
			return result;
		}
	}
}


static gboolean game_view_real_button_press_event (GtkWidget* base, GdkEventButton* event) {
	GameView * self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	self = (GameView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ == ((guint) 1)) {
		gint x = 0;
		GdkEventButton* _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint y = 0;
		GdkEventButton* _tmp8_ = NULL;
		gdouble _tmp9_ = 0.0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gint _tmp17_ = 0;
		_tmp2_ = event;
		_tmp3_ = _tmp2_->x;
		_tmp4_ = game_view_get_x_offset (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = game_view_get_tile_size (self);
		_tmp7_ = _tmp6_;
		x = ((gint) (_tmp3_ - _tmp5_)) / (_tmp7_ + GAME_VIEW_GRID_WIDTH);
		_tmp8_ = event;
		_tmp9_ = _tmp8_->y;
		_tmp10_ = game_view_get_y_offset (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = game_view_get_tile_size (self);
		_tmp13_ = _tmp12_;
		y = ((gint) (_tmp9_ - _tmp11_)) / (_tmp13_ + GAME_VIEW_GRID_WIDTH);
		_tmp17_ = x;
		if (_tmp17_ >= 0) {
			gint _tmp18_ = 0;
			_tmp18_ = x;
			_tmp16_ = _tmp18_ < 8;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			gint _tmp19_ = 0;
			_tmp19_ = y;
			_tmp15_ = _tmp19_ >= 0;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			gint _tmp20_ = 0;
			_tmp20_ = y;
			_tmp14_ = _tmp20_ < 8;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			gint _tmp21_ = 0;
			gint _tmp22_ = 0;
			_tmp21_ = x;
			_tmp22_ = y;
			g_signal_emit_by_name (self, "move", _tmp21_, _tmp22_);
		}
	}
	result = TRUE;
	return result;
}


static gint game_view_get_tile_size (GameView* self) {
	gint result;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp2_ = MIN (_tmp0_ / 8, _tmp1_ / ((gint) 8));
	result = _tmp2_ - GAME_VIEW_GRID_WIDTH;
	return result;
}


static gint game_view_get_x_offset (GameView* self) {
	gint result;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp1_ = game_view_get_tile_size (self);
	_tmp2_ = _tmp1_;
	result = (_tmp0_ - (8 * (_tmp2_ + GAME_VIEW_GRID_WIDTH))) / 2;
	return result;
}


static gint game_view_get_y_offset (GameView* self) {
	gint result;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp1_ = game_view_get_tile_size (self);
	_tmp2_ = _tmp1_;
	result = (_tmp0_ - (8 * (_tmp2_ + GAME_VIEW_GRID_WIDTH))) / 2;
	return result;
}


static gint game_view_get_board_size (GameView* self) {
	gint result;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = game_view_get_tile_size (self);
	_tmp1_ = _tmp0_;
	result = (_tmp1_ + GAME_VIEW_GRID_WIDTH) * 8;
	return result;
}


Game* game_view_get_game (GameView* self) {
	Game* result;
	Game* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_game;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _game_view_square_changed_cb_game_square_changed (Game* _sender, gint x, gint y, gpointer self) {
	game_view_square_changed_cb ((GameView*) self, x, y);
}


void game_view_set_game (GameView* self, Game* value) {
	Game* _tmp0_ = NULL;
	Game* _tmp2_ = NULL;
	Game* _tmp3_ = NULL;
	Game* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_game;
	if (_tmp0_ != NULL) {
		Game* _tmp1_ = NULL;
		_tmp1_ = self->priv->_game;
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
	}
	_tmp2_ = value;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->_game);
	self->priv->_game = _tmp3_;
	_tmp4_ = self->priv->_game;
	if (_tmp4_ != NULL) {
		Game* _tmp5_ = NULL;
		_tmp5_ = self->priv->_game;
		g_signal_connect_object (_tmp5_, "square-changed", (GCallback) _game_view_square_changed_cb_game_square_changed, self, 0);
		{
			gint x = 0;
			x = 0;
			{
				gboolean _tmp6_ = FALSE;
				_tmp6_ = TRUE;
				while (TRUE) {
					gint _tmp8_ = 0;
					if (!_tmp6_) {
						gint _tmp7_ = 0;
						_tmp7_ = x;
						x = _tmp7_ + 1;
					}
					_tmp6_ = FALSE;
					_tmp8_ = x;
					if (!(_tmp8_ < 8)) {
						break;
					}
					{
						gint y = 0;
						y = 0;
						{
							gboolean _tmp9_ = FALSE;
							_tmp9_ = TRUE;
							while (TRUE) {
								gint _tmp11_ = 0;
								gint* _tmp12_ = NULL;
								gint _tmp12__length1 = 0;
								gint _tmp12__length2 = 0;
								gint _tmp13_ = 0;
								gint _tmp14_ = 0;
								Game* _tmp15_ = NULL;
								gint _tmp16_ = 0;
								gint _tmp17_ = 0;
								Player _tmp18_ = 0;
								gint _tmp19_ = 0;
								gint _tmp20_ = 0;
								if (!_tmp9_) {
									gint _tmp10_ = 0;
									_tmp10_ = y;
									y = _tmp10_ + 1;
								}
								_tmp9_ = FALSE;
								_tmp11_ = y;
								if (!(_tmp11_ < 8)) {
									break;
								}
								_tmp12_ = self->priv->pixmaps;
								_tmp12__length1 = self->priv->pixmaps_length1;
								_tmp12__length2 = self->priv->pixmaps_length2;
								_tmp13_ = x;
								_tmp14_ = y;
								_tmp15_ = self->priv->_game;
								_tmp16_ = x;
								_tmp17_ = y;
								_tmp18_ = game_get_owner (_tmp15_, _tmp16_, _tmp17_);
								_tmp19_ = game_view_get_pixmap (self, _tmp18_);
								_tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_] = _tmp19_;
								_tmp20_ = _tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_];
							}
						}
					}
				}
			}
		}
	}
	game_view_redraw (self);
	g_object_notify ((GObject *) self, "game");
}


const gchar* game_view_get_theme (GameView* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_theme;
	result = _tmp0_;
	return result;
}


void game_view_set_theme (GameView* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_theme);
	self->priv->_theme = _tmp1_;
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
	self->priv->tiles_pattern = NULL;
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "theme");
}


static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static void game_view_class_init (GameViewClass * klass) {
	game_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GameViewPrivate));
	GTK_WIDGET_CLASS (klass)->get_request_mode = game_view_real_get_request_mode;
	GTK_WIDGET_CLASS (klass)->get_preferred_width_for_height = game_view_real_get_preferred_width_for_height;
	GTK_WIDGET_CLASS (klass)->get_preferred_width = game_view_real_get_preferred_width;
	GTK_WIDGET_CLASS (klass)->get_preferred_height = game_view_real_get_preferred_height;
	GTK_WIDGET_CLASS (klass)->draw = game_view_real_draw;
	GTK_WIDGET_CLASS (klass)->button_press_event = game_view_real_button_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_game_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_game_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = game_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_GAME, g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_THEME, g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("move", TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
}


static void game_view_instance_init (GameView * self) {
	self->priv = GAME_VIEW_GET_PRIVATE (self);
	self->priv->render_size = (guint) 0;
	self->priv->tiles_pattern = NULL;
	self->priv->animate_timeout = (guint) 0;
	self->priv->flip_final_result_now = FALSE;
	self->priv->_game = NULL;
	self->priv->_theme = NULL;
}


static void game_view_finalize (GObject* obj) {
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_VIEW, GameView);
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
	_g_object_unref0 (self->priv->_game);
	_g_free0 (self->priv->_theme);
	G_OBJECT_CLASS (game_view_parent_class)->finalize (obj);
}


GType game_view_get_type (void) {
	static volatile gsize game_view_type_id__volatile = 0;
	if (g_once_init_enter (&game_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameView), 0, (GInstanceInitFunc) game_view_instance_init, NULL };
		GType game_view_type_id;
		game_view_type_id = g_type_register_static (GTK_TYPE_DRAWING_AREA, "GameView", &g_define_type_info, 0);
		g_once_init_leave (&game_view_type_id__volatile, game_view_type_id);
	}
	return game_view_type_id__volatile;
}


static void _vala_game_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
	switch (property_id) {
		case GAME_VIEW_GAME:
		g_value_set_object (value, game_view_get_game (self));
		break;
		case GAME_VIEW_THEME:
		g_value_set_string (value, game_view_get_theme (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_game_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
	switch (property_id) {
		case GAME_VIEW_GAME:
		game_view_set_game (self, g_value_get_object (value));
		break;
		case GAME_VIEW_THEME:
		game_view_set_theme (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



